#include "modc.h"
#include "669.h"
#include "effects.h"
#include "misc.h"
#include <stdlib.h>
#include <fstream.h>

extern ifstream f;

//###################################  669  ###############################################################

static int32 bufsize,result,reached,unilong;
static byte *pbuffer;

void f669_getfiledata(void) {
   
typedef t669note notearray[2048];
typedef notearray *pnotearray;
      
  //*****convert all patterns *******
  for( i=0 ;i<numpatterns;i++ ) for( j=0 ;j<numtracks;j++) (*tracks)[i][j]=numtracks*parrangement[i]+j;//??
  bufsize=64*sizeof(t669note)*numtracks;
  pbuffer=malloc(bufsize);
  for( i=0 ;i <= lastpattern;i++)
  {
    //convert single  pattern
    f.read(pbuffer,bufsize);
    if ( f.gcount()!=bufsize ) { error=id_nomodfile;free(pbuffer);return;}
    if ( alreadyplayed[i] ) for( k=0;k < numtracks;k++)
    {
      reached=false;
      for( j=0 ;j <= 63;j++ ) 
      //with pattern^[1][j],pnotearray(pbuffer)^[j*numtracks+k] do
      {
	//    some aliases
	 byte& byte1 = (*pnotearray(pbuffer))[j*numtracks+k].byte1; 
	 byte& byte2 = (*pnotearray(pbuffer))[j*numtracks+k].byte2; 
	 byte& byte3 = (*pnotearray(pbuffer))[j*numtracks+k].byte3;
	 
	 byte& instrument=(*pattern)[0][j].instrument;
	 word& ton=(*pattern)[0][j].ton;
	 byte& effekt=(*pattern)[0][j].effekt;
	 byte& operands=(*pattern)[0][j].operands;
	 char& chnvol=(*pattern)[0][j].chnvol;
	 
        if ( byte1!=0xff )
        {
          chnvol=((byte2 & 0x0f)<< 2)+((byte2 & 0x0f)>> 2)+((byte2 & 0x0f)>> 3);
          if ( byte1!=0xfe )
          {
            if ( (byte1 >> 2)>0 ) ton=pitchtable[(byte1 >> 2)+1] ;else ton=0;
            instrument=(byte2 >> 4)+((byte1 & 0x03)<< 4)+1;
          } else { ton=0;instrument=0;}
        } else { ton=0;instrument=0;chnvol=-1; }
        if ( (byte3!=0xff))
	 switch (byte3 >> 4) {
	  case 0 : if ( byte3>0 ) { effekt=portamento_up  ;operands=(byte3 & 0x0f);};break;
	  case 1 : { effekt=portamento_down;operands=(byte3 & 0x0f);};break;
          case 2 : { effekt=tone_portamento;operands=(byte3 & 0x0f);};break;
          case 3 : {       //frequency adjust
                effekt   = enhanced;
                operands = (fsldup  << 4) +(byte3 & 0x0f);
              };break;
          case 4 : {       //frequency vibrato
                effekt   = vibrato;
                operands = ((byte3 & 0x0f) << 4) + 1;
              };break;
          case 5 : { effekt=setspeed;operands=(byte3 & 0x0f);};break;
	  case 6 : switch (byte3 & 0x0f ) {
	       case 0: effekt = finepanleft;break;
               case 1: effekt = finepanright;break;
	       default : { effekt = noeffekt; operands = 0; };break;
              };break;
          case 7 : { effekt = slotretrigger; operands = byte3 & 0x0f; };break;
	  default: { effekt=noeffekt;operands=0; };break;
        } else effekt=noeffekt;
        if ( operands==0 ) effekt=noeffekt;
        if ( 
	    (chnvol!=-1)||
	    (effekt!=noeffekt)||
	    (operands!=0)||
	    (ton!=0)||
	    (instrument!=0)
	    ) reached=true;
      }
      if ( reached ) trackwrite(1,64) ; else trackwrite(1,0);
    } else trackwrite(numtracks,0);
  }
  free(pbuffer);
  pbuffer=malloc(65520);
  if ( pbuffer==NULL ) { error=id_nomem;return;}//no memory!
//****reading instruments in memory****
for( i=1 ;i<= numinstruments;i++ ) 
    if ( instruments[i].iend>0 )
  {
     char *const& name=instruments[i].name;
     int32& offset    =instruments[i].offset;
     int32& iend      =instruments[i].iend;
     int32& loopstart =instruments[i].loopstart;
     int32& loopend   =instruments[i].loopend;
     byte& volume     =instruments[i].volume;
     byte& finetune   =instruments[i].finetune;
     byte& bits       =instruments[i].bits;
     word& tuning     =instruments[i].tuning;
    
     offset=songmemofs;
    unilong=0;
    if ( iend>65520 ) bufsize=65520 ; else bufsize=loword(iend);
    do {
       f.read(pbuffer,bufsize);result=f.gcount();
       if ( result>0 ) songmemwrite(pbuffer,result,1);
       unilong+=result;
      if ( (iend-unilong) < bufsize ) bufsize=iend-unilong;
    }
    while ((unilong!=iend)&&(result!=0));
    iend=unilong;
    if ( iend>0 )
    {
      if ( volume>64 ) volume=64;
      if ( loopend>iend ) loopend=iend;
      if ( loopstart>iend ) loopstart=0;
      if ( loopend-loopstart<4 ) { loopstart=0;loopend=0; }
      iend+=offset;
      if ( loopend>0 )
      {
        loopend+=offset;
        loopstart+=offset;
      }
    } else offset=0;
  }
  free(pbuffer);//we don't need the buffer anymore!
}
